/*-----------------------------------------------------------------
/					 Fichier d'entete CAvatar.h						
/------------------------------------------------------------------
Role: dclaration de la classe CBombe
-------------------------------------------------------------------
Versions: 
-------------------------------------------------------------------
23/12/02: regroupement des modifs de Fran et Guillaume
	Modification du constructeur pr gerer l'animation
	Modification de la fonction deplacer qui choisit la bonne image
2/01/03: Francois: corrections sur les indices de tableau utilises dans 
	staticDestruct et qui faisaient une segfault en mode "release"
2/01/03: Francois: correction (sale) du segfault dans ~CAvatar()
	(aucune image n'etant chargee dans _tabImages[i][j] avec i=0, il ne faut pas y toucher)
8/01/03 (G) Modif de explose qui teste si le bonhomme est invicible	
		(G) Modif du constructeur ac estInvincible
12/01/03 (F) SDL_SetColorKey fait directement au chargement des images (a
		necessite l'ajout de "ecran" en parametre du constructeur.
[1/16/2003]	creation des bombes telecommandees => modifs de:
			agit(), detacherBombes(), ~CAvatar(), CAvatar()
			+ ajout de la donnee membre "_aBombeTelecommandee"
------------------------------------------------------------------*/

#include "CAvatar.h"
#include "CGestionnaireEntree.h"


CBruitage CAvatar::_tabBruitageMort[NB_BRUITAGES_MORT];
CBruitage CAvatar::_sonPoserBombe;


///////////////////////////////////////////////////////////////////////////////
//constructeur 
///////////////////////////////////////////////////////////////////////////////
CAvatar::CAvatar(int nbBombesPosables, int dureeDeVieDeLaBombe,
			int dureeDeVieDeLaFlamme, CGestionnaireEntree * ptGestEntree,
			CRound * ptRound, int numeroAvatar, SDL_Surface * ecran)
		:CContenu(),
		 _nbBombesPosables(nbBombesPosables),
		 _dureeDeVieDeLaBombe(dureeDeVieDeLaBombe),
		 _dureeDeVieDeLaFlamme(dureeDeVieDeLaFlamme),
		 _ptGestEntree(ptGestEntree),
		 _ptRound(ptRound),
		 _numeroAvatar(numeroAvatar),

		 _xSurCase(0),	// l'avatare commence au
		 _ySurCase(0),	// milieu de la case.
		 _porteeDeLaBombe(PORTEE_DE_BOMBE_INITIALE),
		 _ptCaseActuelle(NULL),
		 _xCase(0),
		 _yCase(0),
		 _caseDepartEstInitialisee(false),
		 _finInvicibilite(0),
		 _estInvincible(false),
		 _aBombeTelecommandee(false)
{	

	_aura.charger("auraGood.wav");

//parametres pour  l'animation:
	_nbImages = 2;
	_delai = DUREE_IMAGE_AVATAR;	
	_next = 0;
	_imageCourante = 0;
	_sensMouvement = BAS;

	_imageAura = ImageLoad("images/avatars/aura.bmp"); 
	SDL_SetColorKey(_imageAura, SDL_SRCCOLORKEY,SDL_MapRGB(ecran->format, 0, 0, 255));


//chargement des images en fonction du numero d'avatar
	string sImgPath;
	string c[5] = {"0","1","2","3", "4"};
	string numAvatar(c[_numeroAvatar+1]);
	int nImage;

	sens_propagation tabDirections[4] = {HAUT, BAS, GAUCHE, DROITE};
	char * tabChar[4] = {"arriere_", "avant_", "gauche_", "droite_"};
	
	for (int j=0; j < 4; j++)
		for ( nImage = 0; nImage < NB_IMAGES_PAR_DIRECTION; nImage ++)
		{
			sImgPath = "images/avatars/";
			sImgPath.append(tabChar[j]);
			
			sImgPath.append(c[nImage]);	
			sImgPath.append(numAvatar);
			sImgPath.append(".bmp");

			_tabImages[tabDirections[j]][nImage] = ImageLoad(sImgPath.c_str());
			SDL_SetColorKey(_tabImages[tabDirections[j]][nImage], SDL_SRCCOLORKEY,SDL_MapRGB(ecran->format, 0, 0, 255));
		}

	_image = _tabImages[_sensMouvement][_imageCourante];
}



///////////////////////////////////////////////////////////////////////////////
//destructeur de l'avatar: spartion des bombes attaches, liberation de l'image
//et du son
///////////////////////////////////////////////////////////////////////////////
CAvatar::~CAvatar()
{
	
	
	// On separe de lui les bombes posees par l'avatar qd il meurt
	vector<CBombe*>::iterator it = _vectMesBombes.begin();
	for (;it != _vectMesBombes.end(); it++)
	{
		(*it)->setAvatarPoseurNULL();
	}
	_vectMesBombes.clear();

	list<CBombe*>::iterator itl = _listMesBombesTelecommandees.begin();
	for (;itl != _listMesBombesTelecommandees.end(); itl++)
	{
		(*itl)->setAvatarPoseurNULL();
	}
	_listMesBombesTelecommandees.clear();
	
	SDL_FreeSurface(_imageAura);
	_aura.liberer();
	
	//on libere la mmoire des images
	for (int i=1; i < 5; i++)
		for(int j=0; j < 3; j++)
			SDL_FreeSurface(_tabImages[i][j]);
}


/*
///////////////////////////////////////////////////////////////////////////////
//retourne le booleen indiquant l'invincibilit
///////////////////////////////////////////////////////////////////////////////
bool CAvatar::estInvincible()
{
	return (_estInvincible);
}
*/


///////////////////////////////////////////////////////////////////////////////
//Positionne l'avatar sur les coord de case parametres 
///////////////////////////////////////////////////////////////////////////////
void CAvatar::initialiserCaseDepart(int xCase, int yCase)
{
	_xCase = xCase;
	_yCase = yCase;
	_ptCaseActuelle = _ptRound->getCase(_xCase, _yCase);
	_caseDepartEstInitialisee = true;
}




///////////////////////////////////////////////////////////////////////////////
//Fonctions modifiant des donnes membres de l'avatar
//utilisees par CBonus
///////////////////////////////////////////////////////////////////////////////

void CAvatar::incrementerNbBombesPosables()
{
	assert(_caseDepartEstInitialisee);
	_nbBombesPosables++;
}

void CAvatar::incrementerPorteeBombes()
{
	if (_porteeDeLaBombe < PORTEE_DE_BOMBE_MAX)
		_porteeDeLaBombe++;
}

void CAvatar::incrementerVitesse()
{
	if (_vitesse < 0.01)
	_vitesse += (float)0.001;
}




///////////////////////////////////////////////////////////////////////////////
//recupere 2 structure (structDeplacement et structAction) a
//partir du gestionnaireDePeripherique
//ensuite on appelle successivement:
//deplacer(structDeplacement )
//agir(structAction)
///////////////////////////////////////////////////////////////////////////////
void CAvatar::vis2()
{
	assert(_caseDepartEstInitialisee);
	
	//test de la fin de l'invincibilite: si fin, alors arret du son
	if (_estInvincible == true)
		if (SDL_GetTicks() > _finInvicibilite)
		{
			_estInvincible = false;
			_aura.stop();
		}


	SDeplacement essaiDeplacement = _ptGestEntree->getDeplacement(_numeroAvatar);
	SAction essaiAction = _ptGestEntree->getAction(_numeroAvatar);

	deplacer(essaiDeplacement);
	agir(essaiAction);
}


///////////////////////////////////////////////////////////////////////////////
//Fonction de deplacement calculant si le deplacement et possible.
//Son rle est de permettre un dplacement fluide, naturel et simple de l'avatar
//=> Dans le cas ou ce que l'utilisateur demande est impossible, on va essayer de
//"deviner" ce qu'il veut faire.
//De plus, cette fonction choisit l'image  afficher dans l'animation, en fonction
//du sens de l'avatar et du temps
//////////////////////////////////////////////////////////////////////////////
void CAvatar::deplacer(SDeplacement essaiDeplacement)
{
	assert(_caseDepartEstInitialisee);
	Uint32 heureActuelle;
	float dureeEntre2ImagesEnMS;
	float deplacementFrac;
	
	int xDesire = _xCase + essaiDeplacement.x1erChoix;
	int yDesire = _yCase + essaiDeplacement.y1erChoix;
	
	CCase * caseDesiree = _ptRound->getCase(xDesire, yDesire);
	
	heureActuelle = SDL_GetTicks();

		
	dureeEntre2ImagesEnMS = float(heureActuelle - _heurePrecedente);
	_heurePrecedente = heureActuelle;	// pour le prochain appel

	deplacementFrac = dureeEntre2ImagesEnMS * _vitesse;

	if (_estInvincible)
		deplacementFrac = deplacementFrac / VITESSE_MALUS;


	///////////////////////////////////////////////////////////////////
	// TEST SI DEPLACEMENT POSSIBLE. SI NON=> TROUVER 1 DEPLACMENT QUI CONVIENT
	///////////////////////////////////////////////////////////////////
	if ( ! _ptRound->getCase(xDesire, yDesire)->estTraversable() )
	{
		if (essaiDeplacement.y1erChoix != 0 )
		{
			if ( _xSurCase > 0 )
			{
				if ( _ptRound->getCase(xDesire+1, yDesire)->estTraversable() && _ptRound->getCase(xDesire+1, yDesire-essaiDeplacement.y1erChoix)->estTraversable())
				{
					essaiDeplacement.x1erChoix = 1;
					essaiDeplacement.y1erChoix = 0;
				}
			}
			else if ( _xSurCase < 0 )
				if ( _ptRound->getCase(xDesire-1, yDesire)->estTraversable() && _ptRound->getCase(xDesire-1, yDesire-essaiDeplacement.y1erChoix)->estTraversable())
				{
					essaiDeplacement.x1erChoix = -1;
					essaiDeplacement.y1erChoix = 0;
				}

		}
		else if (essaiDeplacement.x1erChoix != 0 )
		{
			if ( _ySurCase > 0 )
			{
				if ( _ptRound->getCase(xDesire, yDesire+1)->estTraversable() && _ptRound->getCase(xDesire-essaiDeplacement.x1erChoix, yDesire+1)->estTraversable())
				{
					essaiDeplacement.x1erChoix = 0;
					essaiDeplacement.y1erChoix = 1;
				}
			}
			else if ( _ySurCase < 0 )
				if ( _ptRound->getCase(xDesire, yDesire-1)->estTraversable() && _ptRound->getCase(xDesire-essaiDeplacement.x1erChoix, yDesire-1)->estTraversable())
				{
					essaiDeplacement.x1erChoix = 0;
					essaiDeplacement.y1erChoix = -1;
				}

		}
	}
		
	// En fonction des changements apportes au choix "brut" de l'
	// utilisateur, il faut modifier la case desiree en consequence
	xDesire = _xCase + essaiDeplacement.x1erChoix;
	yDesire = _yCase + essaiDeplacement.y1erChoix;
	caseDesiree = _ptRound->getCase(xDesire, yDesire);


	///////////////////////////////////////////////////////////////////
	////////////// POSITIONNEMENT AVANT DEPLACEMENT ///////////////////
	///////////////////////////////////////////////////////////////////
	if (_ptRound->getCase(xDesire, yDesire)->estTraversable() )
	{	// si la case sur laquelle on veut aller est traversable, il faut d'abord
		// bien se positionner avant de se diriger vers elle.
		if (essaiDeplacement.x1erChoix != 0 && fabs(_ySurCase) > 0)
		{	// on veut se deplacer sur x mais il faut d'abord se positionner en ySurCase=0
			if ( fabs(_ySurCase) < DELTA_POSITION )
				_ySurCase = 0;
			else if ( _ySurCase < 0 )
			{
				essaiDeplacement.x1erChoix = 0;
				essaiDeplacement.y1erChoix = 1;
			}
			else
			{
				essaiDeplacement.x1erChoix = 0;
				essaiDeplacement.y1erChoix = -1;
			}
		}
		else if (essaiDeplacement.y1erChoix != 0 && fabs(_xSurCase) > 0)
		{	// on veut se deplacer sur y mais il faut d'abord se positionner en xSurCase=0
			if ( fabs(_xSurCase) < DELTA_POSITION )
				_xSurCase = 0;
			else if ( _xSurCase < 0 )
			{
				essaiDeplacement.x1erChoix = 1;
				essaiDeplacement.y1erChoix = 0;
			}
			else
			{
				essaiDeplacement.x1erChoix = -1;
				essaiDeplacement.y1erChoix = 0;
			}
		}
	}

	// En fonction des changements apportes, il faut modifier la case desiree en consequence
	xDesire = _xCase + essaiDeplacement.x1erChoix;
	yDesire = _yCase + essaiDeplacement.y1erChoix;
	caseDesiree = _ptRound->getCase(xDesire, yDesire);
	

	///////////////////////////////////////////////////////////////////
	//////////////////// DEPLACEMENT EFFECTIF /////////////////////////
	///////////////////////////////////////////////////////////////////
	if (essaiDeplacement.x1erChoix != 0 )
	{	// si l'on veut bouger sur le cote alors:
	
		float deplacementPixelX = (float)TAILLE_SPRITE_X * deplacementFrac;
		_xSurCase += (int)(deplacementPixelX * essaiDeplacement.x1erChoix);

		if ( (fabs(_xSurCase) > TAILLE_SPRITE_X/2) && caseDesiree->estTraversable() )
		{	// Cas d'un changement de case
			_xSurCase %= TAILLE_SPRITE_X/2;	// Pour eviter les effets "sauts de case" dans le cas d'une machine lente
			_xSurCase = _xSurCase - essaiDeplacement.x1erChoix * TAILLE_SPRITE_X/2;
			
			// Parcour des elements deja presents sur
			// la case pour dire "coucou j'arrive"
			list<CContenu*>::iterator itContenu = caseDesiree->begin();
			for (;itContenu != caseDesiree->end(); itContenu++)
				(*itContenu)->toucheAvatar(this);
			
			// Changement de case effectif
			caseDesiree->push_back(this);
			_aChangeDeCase = true;
			_xCase = xDesire;
			_yCase = yDesire;
		}
		else if ( ! caseDesiree->estTraversable() )
		{	// on veut changer de case mais elle n'est pas traversable => on reste au milieu de la case actuelle
			if ( (_xSurCase > 0) && (essaiDeplacement.x1erChoix > 0) )
				_xSurCase = 0;
			else if ( (_xSurCase < 0) && (essaiDeplacement.x1erChoix < 0) )
				_xSurCase = 0;
		}
	}
	
	else if (essaiDeplacement.y1erChoix != 0 )
	{	// si l'on veut bouger sur y alors:
		
		float deplacementPixelY = (float)TAILLE_SPRITE_Y * deplacementFrac;
		_ySurCase += (int)(deplacementPixelY * essaiDeplacement.y1erChoix);
		
		if ( (fabs(_ySurCase) > TAILLE_SPRITE_Y/2) && caseDesiree->estTraversable() )
		{	// Cas d'un changement de case
			_ySurCase %= TAILLE_SPRITE_Y/2;	// Pour eviter les sauts de case dans le cas d'une machine lente
			_ySurCase = _ySurCase - essaiDeplacement.y1erChoix * TAILLE_SPRITE_Y/2 ;
			

			// Parcour des elements deja presents sur
			// la case pour dire "coucou j'arrive"
			list<CContenu*>::iterator itContenu = caseDesiree->begin();
			for (;itContenu != caseDesiree->end(); itContenu++)
				(*itContenu)->toucheAvatar(this);

			// Changement de case effectif
			caseDesiree->push_back(this);
			_aChangeDeCase = true;
			_xCase = xDesire;
			_yCase = yDesire;
		}
		else if ( ! caseDesiree->estTraversable() )
		{	// on veut changer de case mais elle n'est pas traversable => on reste au milieu de la case actuelle
			if ( (_ySurCase > 0) && (essaiDeplacement.y1erChoix > 0) )
				_ySurCase = 0;
			else if ( (_ySurCase < 0) && (essaiDeplacement.y1erChoix < 0) )
				_ySurCase = 0;
		}
	}

//affectation du sens du mvt:
	if (essaiDeplacement.x1erChoix > 0) 
		_sensMouvement = DROITE;

	if (essaiDeplacement.x1erChoix < 0) 
		_sensMouvement = GAUCHE;

	if (essaiDeplacement.y1erChoix < 0) 
		_sensMouvement = HAUT;

	if (essaiDeplacement.y1erChoix > 0) 
		_sensMouvement = BAS;
	

///choix de l'image  afficher...
	SDL_Surface* imageChoisie;

	//cette fonction choisi l'image d'arret si pas de mouvement
	if ( (essaiDeplacement.x1erChoix == 0) && (essaiDeplacement.y1erChoix == 0) )
		imageChoisie = _tabImages[_sensMouvement][0];
	
	else	
	{  
		Uint32 temps_actuel = SDL_GetTicks();

		//si on a depasse le temps, on change d'image.
		if ( temps_actuel > _next)
		{
			_next = temps_actuel + _delai;
			_imageCourante++;

			if (_imageCourante > _nbImages )
				_imageCourante = 1;
				
		}

		//affectation de l'image choisie
		imageChoisie = _tabImages[_sensMouvement][_imageCourante];
	}

	_image = imageChoisie;
}


///////////////////////////////////////////////////////////////////////////////
//Cette fonction teste si le bouton d'action a t appuy
//si c'est le cas, une bombe est cre et posee sur la case de l'avatar poseur
//si l'avatar est invincible, la bombe explosera immediatement (duree de bombe  0
/////////////////////////////////////////////////////////////////////////////
void CAvatar::agir(SAction essaiAction)
{
	if (essaiAction.bouton1)
	{
		_ptCaseActuelle = _ptRound->getCase(_xCase, _yCase);
		if ( _ptCaseActuelle->estTraversable() && (_nbBombesPosables > 0) )
		{
			if (_aBombeTelecommandee)
			{
				// poser une bombe telecommandee (duree de vie de 0 par convention)
				CBombe * ptBombT = new CBombe(0,_dureeDeVieDeLaFlamme,
											_porteeDeLaBombe, _xCase, _yCase, this);
				_listMesBombesTelecommandees.push_back(ptBombT);
				_ptCaseActuelle->push_back(ptBombT);
			}
			else
			{
				CBombe * ptBomb;
				if ( _estInvincible )
					ptBomb = new CBombe(1,_dureeDeVieDeLaFlamme,
											_porteeDeLaBombe, _xCase, _yCase, this);

				else
				{	_sonPoserBombe.jouer();
					ptBomb = new CBombe(_dureeDeVieDeLaBombe,_dureeDeVieDeLaFlamme,
											_porteeDeLaBombe, _xCase, _yCase, this);
				}
					
				// L'avatar garde la trace de ses bombes (pour les "liberer" s'il
				// meurt avant leur explosion
				_vectMesBombes.push_back(ptBomb);
				// Insertion de la nouvelle bombe dans le contenu de la case
				_ptCaseActuelle->push_back(ptBomb);
			}
			_nbBombesPosables--;
		}
	}

	if ( essaiAction.bouton2 && _aBombeTelecommandee )
	{
		list<CBombe*>::iterator itl = _listMesBombesTelecommandees.begin();
		for (; itl != _listMesBombesTelecommandees.end(); itl++)
			(*itl)->setMomentExplosion(1);	// on a toujours 1 < getTicks donc les bombes exploseront immediatement
	}
}

/////////////////////////////////////////////////////////////////////////////
//a ce stade, _adetruire est a true (positionne par enflammeToi, qui appelle explose, car 
//l'avatar est alle sur une flamme.
//on peut alors modifier l'attribut si l'avatar est invincible
/////////////////////////////////////////////////////////////////////////////
void CAvatar::explose()
{
	int randomNB = (int)(NB_BRUITAGES_MORT * float(rand())/float(RAND_MAX));
	if (SDL_GetTicks() > _finInvicibilite)
	{
		_estInvincible = false;
		_finInvicibilite = 0;
	}

	//si l'avatar est invincible, on remet _adetruire a vrai
	if ( _estInvincible )
		_aDetruire = false;
	else
		_tabBruitageMort[randomNB].jouer();
}


/////////////////////////////////////////////////////////////////////////////
int CAvatar::continueDestruction()
{
	_estBienDetruit = false;
	return _numeroAvatar;
}


/*
/////////////////////////////////////////////////////////////////////////////
// un avatar peut traverser 1 autre avatar
/////////////////////////////////////////////////////////////////////////////
bool CAvatar::estTraversable()
{
	return true;	// un avatar peut traverser 1 autre avatar
}
*/


/////////////////////////////////////////////////////////////////////////////
//Affichage de l'image de l'avatar. si celui ci est invincible, on affiche egalement
//une aura dessus (legerement transparente) et dessous
/////////////////////////////////////////////////////////////////////////////
void CAvatar::afficheToi(SDL_Rect coord_info, SDL_Surface * screen)
{
	coord_info.y -= TAILLE_SPRITE_Y;
	coord_info.x += _xSurCase ;
	coord_info.y += _ySurCase ;
	
	if (_estInvincible)
	{
		SDL_BlitSurface(_imageAura,NULL,screen,&coord_info);
		SDL_BlitSurface(_image,NULL,screen,&coord_info);
		SDL_SetAlpha(_imageAura,SDL_SRCALPHA, 128);
		SDL_BlitSurface(_imageAura,NULL,screen,&coord_info);
	}
	else
		SDL_BlitSurface(_image,NULL,screen,&coord_info);
}



/////////////////////////////////////////////////////////////////////////////
//Fonction servant a rendre l'avatar invincible quand il prend le bonus d'invincibilite, 
//ou "super saien".
/////////////////////////////////////////////////////////////////////////////
void CAvatar::rendreInvincible()
{
	_finInvicibilite = SDL_GetTicks() + DUREE_INVINCIBILITE;
	_estInvincible = true;
	_aura.jouer();
}


/////////////////////////////////////////////////////////////////////////////
void CAvatar::detacherBombe(CBombe * ptBombe)
{
	bool bBombeTrouvee = false;
	bool bPassageDansBoucle = false;

	// On cherche dans les bombes normales...
	vector<CBombe*>::iterator it = _vectMesBombes.begin();
	for (;it != _vectMesBombes.end(); it++)
	{
		bPassageDansBoucle = true;
		if ( (*it) == ptBombe)
		{
			_vectMesBombes.erase(it);
			it--;
			bBombeTrouvee = true;
		}
	}

	if ( !bBombeTrouvee )
	{	// ...si la bombes n'a pas ete trouvee dans les normales,
		// on cherche dans les bombes telecommandees

		list<CBombe*>::iterator itl = _listMesBombesTelecommandees.begin();
		for (;itl != _listMesBombesTelecommandees.end() && (!bBombeTrouvee); itl++)
		{
			bPassageDansBoucle = true;
			if ( (*itl) == ptBombe)
			{
				_listMesBombesTelecommandees.erase(itl);
				itl--;
				bBombeTrouvee = true;
			}
		}
	}	
	assert (bPassageDansBoucle);
	assert (bBombeTrouvee);
}


/////////////////////////////////////////////////////////////////////////////
//Chargement des sons communs a tous les avatars: bruits d'agonie et de bombe
/////////////////////////////////////////////////////////////////////////////
void CAvatar::staticInit()
{
	// Chargement des sons des explosions
	for (int i = 0; i<NB_BRUITAGES_MORT; i++)
	{
		string fichier = "mort";
		char tmp2[255];
		char tmp;
		sprintf(tmp2, "%d", i);
		tmp = tmp2[0];
		fichier = fichier + tmp;
		fichier = fichier + ".wav";
		CAvatar::_tabBruitageMort[i].charger(fichier.c_str());
	}
	_sonPoserBombe.charger("bombe.wav");
}


/////////////////////////////////////////////////////////////////////////////
//liberation des sons communs
//////////////////////////////////////////////////////////////////////////////
void CAvatar::staticDestruct()
{
	for (int i = 0; i<NB_BRUITAGES_MORT; i++)
		CAvatar::_tabBruitageMort[i].liberer();
	CAvatar::_sonPoserBombe.liberer();
}



