/*-----------------------------------------------------------------
/					 Fichier d'entete CBombe.h						
/------------------------------------------------------------------
Role: dclaration de la classe CBombe
-------------------------------------------------------------------
Versions: 
-------------------------------------------------------------------
23/12/02: regroupement des modifs de Fran et Guillaume
	Rajout des fonctions  chargerImages(); supprimerImages(); et des
	variables _imageCourante, _delai, _tpsProchaineImage, _images
 [1/16/2003] - Creation de la fonction setMomentExplosion() pour 
				faire exploser les bombes telecommandees
------------------------------------------------------------------*/

#if !defined(CBombe_h)
#define CBombe_h

#include "CContenu.h"
#include "CCase.h"
#include "CFlamme.h"
#include "CAvatar.h"
#include "CFMODWrapper.h"
#include "utils.h"

class CRound;


class CBombe : public CContenu
{
public:
	CBombe(int dureeDeVie, int dureeDeVieFlamme,
			   int portee, int x, int y, CAvatar * poseur);
	virtual ~CBombe();

	static void staticInit(CRound * ptRound, SDL_Surface * screen);
	static void staticDestruct();

    void explose();
	
    inline int continueDestruction()
	{	_estBienDetruit = true; return -1;	}
	
	inline bool estTraversable()
	{	return false;	}
	
	inline void setAvatarPoseurNULL()	// l'avatar qui meurt doit separer ses bombes de lui-meme en 
	{	_ptAvatarPoseur = NULL; }		// mettant "_ptAvatarPoseur" a NULL.

	inline void setMomentExplosion(Uint32 momentExplosion)
	{ _momentExplosion = momentExplosion;}
	
	void afficheToi(SDL_Rect coord_info, SDL_Surface * screen);

protected:
	void vis2();

private:
    Uint32	_momentExplosion;
    int	_portee;
    int	_dureeDeVieFlamme;	// en millisecondes
    
	int _xCase;
	int _yCase;
	
    static CRound * _ptRound;
    CAvatar *	_ptAvatarPoseur;

	int _imageCourante;
	int _delai;					//le temps entre chaque image.
	Uint32 _tpsProchaineImage;	//le temps de debut de pose d'une bombe.
	static SDL_Surface** _tabImages;
	static SDL_Surface** _tabImagesBombeTelecommandee;

	static CBruitage _tabBruitageExplosion[NB_BRUITAGES_EXPLOSION];

	#ifdef DEBUG
		bool verifierCoherence();
	#endif
};

#endif /* CBombe_h */
