/*-----------------------------------------------------------------
/					 Fichier  CBonus.cpp
/------------------------------------------------------------------
Role: implmentation de la classe CBonus qui definit les divers types
	de bonus.
-------------------------------------------------------------------
Versions: (depuis regroupement du 22/12/02)
-------------------------------------------------------------------
8/01/03: Rajout de bonus: BONUS_PORTEE_MAX
[1/16/2003] Francois - creation du bonus TELECOMMANDEE + simplifications du constructeur
------------------------------------------------------------------*/

#include "CBonus.h"

CBruitage CBonus::_sonBonus;
SDL_Surface* CBonus::_imagesBonus[sizeof(typeBonus)];


//////////////////////////////////////////////////////////////////
//constructeur: choix d'une image en fonction du type de bonus
//////////////////////////////////////////////////////////////////
CBonus::CBonus(typeBonus type)
:_type(type)
{
	_image = _imagesBonus[type];
			
	assert(type == BONUS_PORTEE_BOMBE || type == BONUS_NB_BOMBES
			 || type == BONUS_PORTEE_MAX || type == BONUS_INVINCIBILITE
			 || type == BONUS_VITESSE || type == BONUS_TELECOMMANDEE);

}


//////////////////////////////////////////////////////////////////
CBonus::~CBonus()
{
}

/*
//////////////////////////////////////////////////////////////////
int CBonus::continueDestruction()
{
	_estBienDetruit = true;
	return -1;
}



//////////////////////////////////////////////////////////////////
bool CBonus::estTraversable()
{return true;}
*/


//////////////////////////////////////////////////////////////////
void CBonus::afficheToi(SDL_Rect coord_info, SDL_Surface * screen)
{
	SDL_SetColorKey(_image, SDL_SRCCOLORKEY,SDL_MapRGB(screen->format, 0, 0, 255)); 
	SDL_BlitSurface(_image,NULL,screen,&coord_info);

}

/*
//////////////////////////////////////////////////////////////////
void CBonus::vis2()
{
}
*/


//////////////////////////////////////////////////////////////////
void CBonus::staticDestruct()
{
	int i;
	for (i=0; i<4; i++)
		SDL_FreeSurface(_imagesBonus[i]);

	_sonBonus.liberer();
}


//////////////////////////////////////////////////////////////////
void CBonus::staticInit()
{
	_sonBonus.charger("bonus.wav");
	_imagesBonus[0] = ImageLoad("images/bonus/BonusPorteeBombe.bmp");
	_imagesBonus[1] = ImageLoad("images/bonus/BonusNBBombes.bmp");
	_imagesBonus[2] = ImageLoad("images/bonus/BonusPorteeMax.bmp");
	_imagesBonus[3] = ImageLoad("images/bonus/BonusInvincibilite.bmp");
	_imagesBonus[4] = ImageLoad("images/bonus/BonusVitesse.bmp");
	_imagesBonus[5] = ImageLoad("images/bonus/BonusTelecommande.bmp");

}



//////////////////////////////////////////////////////////////////
//appele quand un avatar se deplace sur une case ou se trouve le bonus
//le bonus se detruit et peut agir sur l'avatar (pointeur paramtre
//et fonctions membres
//////////////////////////////////////////////////////////////////
void CBonus::toucheAvatar(CAvatar * ptAvatar)
{
	this->_aDetruire = true;
	int i;

	switch (_type)
	{
		case BONUS_PORTEE_BOMBE:
			ptAvatar->incrementerPorteeBombes();
			_sonBonus.jouer();
			break;

		case BONUS_PORTEE_MAX:
			for (i=0; i< 17; i++)
				ptAvatar->incrementerPorteeBombes();
				_sonBonus.jouer();
			break;

		case BONUS_NB_BOMBES:
			ptAvatar->incrementerNbBombesPosables();
			_sonBonus.jouer();
			break;

		case BONUS_INVINCIBILITE:
			ptAvatar->rendreInvincible();
			_sonBonus.jouer();
			break;

		case BONUS_VITESSE:
			ptAvatar->incrementerVitesse();
			_sonBonus.jouer();
			break;

		case BONUS_TELECOMMANDEE:
			ptAvatar->setABombeTelecommandeesTRUE();
			_sonBonus.jouer();
			break;

		default:
			assert(false);
	}
	
}




