/*-----------------------------------------------------------------
/					 Fichier d'entete CBonus.h
/------------------------------------------------------------------
Role: dclaration de la classe CBonus qui definit les divers types
	de bonus.
-------------------------------------------------------------------
Versions: (depuis regroupement du 22/12/02)
-------------------------------------------------------------------
8/01/03: Rajout de bonus: BONUS_PORTEE_MAX; BONUS_INVINCIBILITE.
// [1/16/2003] Francois - rajout de BONUS_TELECOMMANDEE
						- _imagesBonus est initialise par [sizeof(typeBonus)]
------------------------------------------------------------------*/

#if !defined(CBonus_h)
#define CBonus_h


#include "CContenu.h"
#include "CAvatar.h"
#include "CFMODWrapper.h"
#include "utils.h"

typedef enum {BONUS_PORTEE_BOMBE, BONUS_NB_BOMBES,
			BONUS_PORTEE_MAX, BONUS_INVINCIBILITE,
			BONUS_VITESSE, BONUS_TELECOMMANDEE} typeBonus;


///////////////////////// CBONUS /////////////////////////////////////
class CBonus : public CContenu
{
	public:
		CBonus(typeBonus type);
		virtual ~CBonus();
		inline virtual int continueDestruction()
		{	_estBienDetruit = true;	return -1; }
		inline virtual bool estTraversable()
		{	return true; }
		virtual void toucheAvatar(CAvatar * ptAvatar);

		virtual void afficheToi(SDL_Rect coord_info, 
			SDL_Surface * screen);

		static void staticInit();
		static void staticDestruct();
	
	protected:
		inline void vis2(){};

	private:
		static CBruitage _sonBonus;	
		static SDL_Surface* _imagesBonus[sizeof(typeBonus)];	//5 bonus differents
		
		typeBonus _type;
};



#endif
