/////////////////////////////////////////////////////////////////////////
// CContenu.h
//tous les contenus de case drivent de CContenu:flammes, bonus, bombes,
//avatars
//////////////////////////////////////////////////////////////////////////


#if !defined(CContenu_h)
#define CContenu_h

#include "CSDLSprite.h"
#include "utils.h"	// pour vector


class CAvatar;	//  pour eviter une
				// inclusion circulaire => Cavatar.h est inclus,
				// mais seulement dans CContenu.cpp

class CContenu : public CSDLSprite
{
public:
	
	CContenu();
	virtual ~CContenu();
    virtual void toucheAvatar(CAvatar * ptAvatar) {};
	virtual int continueDestruction() = 0;
	virtual bool estTraversable() = 0;
	
    void enflammeToi();	// ne pas redefinir dans les classes 
						// derivees mais utiliser explose() qui est
						// appele automatiquement par  enflammeToi().
							
    
    void vis();			// appelle vis2() automatiquement
	
	inline bool estADetruire()
	{	return _aDetruire; }

	inline bool estDetruit()	// si oui alors on peut faire un delete de l'objet
    {	return _estBienDetruit; }
	inline bool aDejaVecu()
	{	return _bADejaVecu;	}
	inline void setADejaVecuFalse()
	{	_bADejaVecu = false; }
	
	bool aChangeDeCase() {return _aChangeDeCase;}
	void setAChangeDeCaseFalse() {_aChangeDeCase = false;}

	

protected:
	virtual void vis2() = 0;	// Fonction specifique a chaque classe derivant de CContenu a redefinir. Elle est appelee par "vis()"
	virtual void explose() {};	// Si rien, alors pasbesoin de redefinircette fonction
	
	float _vitesse;
	
	bool _aChangeDeCase;
	bool _aDetruire;
	bool _estBienDetruit;	// permet de laisser un temps de latence
							// (pour une animation par exemple) entre le moment ou l'on sait
							// que l'objet est a detruire et le moment ou il est effectivement detruit
	
private:
	bool _bADejaVecu;		// indique si dans un tour de jeux on a deja appele la foction vis() de l'avatar
};

#endif /* CContenu_h */
