// cEcranAccueil.cpp: implementation of the cEcranAccueil class.
//
//////////////////////////////////////////////////////////////////////

#include "CEcranAccueil.h"
using namespace std;

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////
CEcranAccueil::CEcranAccueil(SDL_Surface* ecran)
:_ecran(ecran),
 _position_actuelle(0),
 _done(false),
 _bruitageDing("menu_ding.wav"),
 _bruitageDone("explosion3.wav")
{
//definition des positions de la bombe
//devant nouvelle partie
	_position_bombe[0].x = 252;
	_position_bombe[0].y = 264;
	
//devant options 
	_position_bombe[1].x = 345;
	_position_bombe[1].y = 370;

//devant credit
	_position_bombe[2].x = 345;
	_position_bombe[2].y = 485;

//devant quitter
	_position_bombe[3].x = 345;
	_position_bombe[3].y = 600;


	//on charge les images de la bombe
	load_sprite(_bombe_image[1],&_bombe,"images/bombe1.bmp",_ecran, 100);
	load_sprite(_bombe_image[2],&_bombe,"images/bombe2.bmp",_ecran, 100);
	load_sprite(_bombe_image[3],&_bombe,"images/bombe3.bmp",_ecran, 100);
	load_sprite(_bombe_image[4],&_bombe,"images/bombe2.bmp",_ecran, 100);
	
	//l'explosion est rapide..
	load_sprite(_explosion_image[1],&_explosion,"images/bombex.bmp",_ecran,75);
	load_sprite(_explosion_image[2],&_explosion,"images/bombex2.bmp",_ecran,75);

	//et on rentre les paramtres de l'animation
	_bombe.position.x = _position_bombe[_position_actuelle].x;
    _bombe.position.y = _position_bombe[_position_actuelle].y;
	_bombe.to_frame= 4; 
	_bombe.looping_anim=true;

	_explosion.position.x = _position_bombe[_position_actuelle].x;
    _explosion.position.y = _position_bombe[_position_actuelle].y;
	_explosion.to_frame= 2; 
	_explosion.looping_anim=false;
}



//////////////////////////////////////////////////////////////////////////
//liberation des images d'anim
//////////////////////////////////////////////////////////////////////////
CEcranAccueil::~CEcranAccueil()
{	
	int i;
	for	(i=1; i < 5;i++)
	{
		SDL_FreeSurface(_bombe_image[i]);
		if (i < 3)
		{
			SDL_FreeSurface(_explosion_image[i]);
		}
	}

}


//////////////////////////////////////////////////////////////////////////
//gere l'ecran d'accueil. renvoie un T_etatAccueil correxpondant au choix
//utilisateur valide par entree. Ce choix est determine par la _positionactuelle
//de la bombe
//////////////////////////////////////////////////////////////////////////
T_EtatAccueil CEcranAccueil::gereToi()
{
	
	int duree_anim = 700;
	Uint32 temps_courant = SDL_GetTicks(); 
	Uint32 temps_fin = temps_courant + duree_anim;

//on commence par charger le fond d'cran, puis la bombe
	_fondEcran = ImageLoad("images/menus/menu.bmp");
	
	SDL_BlitSurface(_fondEcran,NULL,_ecran,NULL);
	SDL_BlitSurface(_bombe_image[_bombe.frame], NULL, _ecran, &_position_bombe[_position_actuelle]);

	while (! _done )
	{
		gereClavier();
		animation(&_bombe);
		SDL_BlitSurface(_fondEcran,NULL,_ecran,NULL);
		SDL_BlitSurface(_bombe_image[_bombe.frame], NULL, _ecran, &_position_bombe[_position_actuelle]);
		SDL_Flip(_ecran);
	}

//si on quitte c'est qu'on a fait entre: on effectue l'action en consquence
//si la position est 3, c'est qu'on est sur quitter

	while (temps_courant < temps_fin)
	{
		animation(&_explosion);
		SDL_BlitSurface(_fondEcran,NULL,_ecran,NULL);
		SDL_BlitSurface(_explosion_image[_explosion.frame], NULL, _ecran, &_position_bombe[_position_actuelle]);
		SDL_Flip(_ecran);
		temps_courant = SDL_GetTicks(); 
	}

	_done = false;

//on renvoie l'etat qui sera ger par CInterfaceAccueil, celui ci est fonction
//de la position actuele definie par
	switch ( _position_actuelle )
	{
		case 3:	_position_actuelle = 0;
				return QUITTER;
				break;

		case 0: return PARTIE;
				break;
				
		case 1: _position_actuelle = 0;
				return OPTIONS;
				break;

		case 2: _position_actuelle = 0;
				return CREDIT;
				break;
					
		default:	return ACCUEIL;
					break;
	}
	SDL_FreeSurface(_fondEcran);
}



//////////////////////////////////////////////////////////////////////////
//gestion du clavier: appuyer sur haut et bas change la position actuelle 
//appuyer sur entrer valide cette position et provoque un changement d'etat
//en mettant done  true ->> on sort de la boucle de gereToi
//////////////////////////////////////////////////////////////////////////
void CEcranAccueil::gereClavier()
{
	SDL_Event event;
      while ( SDL_PollEvent(&event) ) 
	  {	
        if ( event.type == SDL_KEYDOWN ) 
		{
			_keystroke=event.key.keysym.sym;
			if (_keystroke==SDLK_UP) 
			{ 
				if (_position_actuelle !=0)
				{	
					_bruitageDing.jouer();
					_position_actuelle --;	
					_position_actuelle %= 4;
					_done = false;
				}
				else
				{
					_bruitageDing.jouer();
					_position_actuelle = 3;
				}
				
			}

			if (_keystroke==SDLK_DOWN) 
			{ 
				_bruitageDing.jouer();
				_position_actuelle ++;	
				_position_actuelle %= 4;
				_done = false;
			}

			if (_keystroke==SDLK_RETURN)
			{
				_bruitageDone.jouer();
				_done = true;
			}

			if (_keystroke==SDLK_ESCAPE)
			{
				exit(0);
			}
		}
      }
      _keys = SDL_GetKeyState(NULL);
}



