// cInterfaceAccueil.cpp: implementation of the cInterfaceAccueil class.
//
//////////////////////////////////////////////////////////////////////

#include "CInterfaceAccueil.h"
using namespace std;

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////



CInterfaceAccueil::CInterfaceAccueil(SDL_Surface* ecran, CConfiguration* configuration)
:_ecran(ecran),
 _etat(ACCUEIL),
 _config(configuration),
 _maMusique("musiqueMenu.mp3"),
 _valider(false)
{}

CInterfaceAccueil::~CInterfaceAccueil()
{
	_maMusique.liberer();
}

T_EtatAccueil CInterfaceAccueil::run()
{
	//cration des diffrents crans
	CEcranAccueil ecranAccueil(_ecran);
	CEcranOptions ecranOptions(_ecran, _config);

	_maMusique.jouer();	

	while ( _etat != QUITTER && _etat != PARTIE)
	{
		switch (_etat)
		{
			case ACCUEIL:	_etat = ecranAccueil.gereToi(); break;
			case OPTIONS:	cout << "appel de ecranOptions.gereToi()" << endl; _etat = ecranOptions.gereToi(); break;
			case PARTIE:	_etat = PARTIE; break;
			case CREDIT:	_etat = afficherCredit(); break;
			default: break;
		}
	}
	
	_maMusique.stop();
	return _etat;
}


T_EtatAccueil CInterfaceAccueil::afficherCredit()
{
	SDL_Surface* ecranCredits = ImageLoad("images/menus/credits.bmp");
	cout << "image charge" << endl;
	_valider = false;
	while ( !_valider)
	{	
		gererClavier();
		SDL_BlitSurface(ecranCredits,NULL,_ecran,NULL);
		SDL_Flip(_ecran);
	}
	SDL_FreeSurface(ecranCredits);
	return ACCUEIL;
}

/*
void CInterfaceAccueil::setEtat(T_EtatAccueil etat)
{
	_etat = etat;
}
*/

void CInterfaceAccueil::gererClavier()
{
	SDL_Event event;
    while ( SDL_PollEvent(&event) ) 
	{	
		if ( event.type == SDL_KEYDOWN ) 
		{
			_keystroke=event.key.keysym.sym;
			if (_keystroke==SDLK_RETURN)
			{
				_valider = true;
			}
		}
     }
     _keys = SDL_GetKeyState(NULL);
}



