/*-----------------------------------------------------------------
/					 Fichier CPartie.cpp						
/------------------------------------------------------------------
Role: dfinition de la classe CPartie
-------------------------------------------------------------------
Versions: 
-------------------------------------------------------------------
4/01/03: (G) modif de partie: c'est un pointeur et non un tablo.
	On passe en parametre  Cround ce pt.
7/01/03: (G) prise en compte de l'etat de match nul:
	modif de run(), et creation de afficherNul();
------------------------------------------------------------------*/

#include "CPartie.h"
#include "CRound.h"


#define REP_NIVEAUX "/niveaux/"
//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

cPartie::cPartie(SDL_Surface* ecran)
{

	_ecran = ecran;
	_musiqueResultat.charger("resultats.mp3");
	//on dfinit la font  utiliser.
	_police = TTF_OpenFont("resources/arbli___.ttf",30);
	assert(_police != NULL );
	
	//chaque joueur  0 rounds gagns au dbut de la partie
	_partie[0] = 0;
	_partie[1] = 0;
	_partie[2] = 0;
	_partie[3] = 0;
}

cPartie::~cPartie()
{
	_musiqueResultat.liberer();
	TTF_CloseFont(_police);
}


void cPartie::run()
{	
	bool fin_de_partie = false;
	int joueurGagnant;


	while ( ! fin_de_partie )
	{
		
		CRound leRound(_config, _partie, _ecran);
		joueurGagnant = leRound.run();
		

	//si le round a eu un gagnant, on affiche le tableau des resultats
	//et on teste si la partie est finie, sinon, on affiche l'ecran de match nul
		if  (joueurGagnant != 0)
		{
			afficherResultat(joueurGagnant);
			fin_de_partie = testerVainqueur(joueurGagnant);
		}
		
		else
			afficherNul();

	}

	afficherGagnant(joueurGagnant);
}


//renvoi vrai si le joueur ayant gagn le dernier round a atteint 
// le nombre de rounds necessaire pr gagner une partie
bool cPartie::testerVainqueur(int numeroJoueur)
{
	if ( _partie[numeroJoueur-1] == _config._nbRounds )
		return true;
	else 
		return false; 
}

//afficher l'cran de match nul: quand les joueurs sont morts en meme temps
//ou que le temps est ecoule
void cPartie::afficherNul()
{

	_musiqueResultat.jouer();
	SDL_Surface* fondEcran;
	fondEcran = ImageLoad("images/menus/fondNul.bmp");
	
	_valider = false;
	while ( ! _valider )
	{
		gererClavier();
		SDL_BlitSurface(fondEcran, NULL, _ecran, NULL);	
		SDL_Flip(_ecran);
	}
	
	SDL_FreeSurface(fondEcran);
	_musiqueResultat.stop();
}


//afficher l'cran de victoire: quand un joueur 
//atteint le nombre de victoire =  nbRounds
void cPartie::afficherGagnant(int numeroJoueur)
{
	SDL_Surface* fondEcran;
	SDL_Color jaune = {254,252,50};
	
	_musiqueResultat.jouer();
	fondEcran = ImageLoad("images/menus/fondVictoire.bmp"); 

	SDL_Surface* joueurs[4] = 
	{
		TTF_RenderText_Blended(_police, "Bien jou, Joueur 1 ! ", jaune),
		TTF_RenderText_Blended(_police, "Bien jou, Joueur 2 ! ", jaune),
		TTF_RenderText_Blended(_police, "Bien jou, Joueur 3 ! ", jaune),
		TTF_RenderText_Blended(_police, "Bien jou, Joueur 4 ! ", jaune),
	};
	
	SDL_Rect position_texte;
	position_texte.x = 400;
	position_texte.y = 500;


	_valider = false;
	while ( ! _valider )
	{
		gererClavier();
		SDL_BlitSurface(fondEcran, NULL, _ecran, NULL);		
		SDL_BlitSurface(joueurs[numeroJoueur-1], NULL, _ecran, &position_texte);	
		SDL_Flip(_ecran);
	}

	_musiqueResultat.stop();
	SDL_FreeSurface(fondEcran);
	for (int i=0; i<4; i++)
		SDL_FreeSurface(joueurs[i]);
	
}



//affiche l'cran de rsultat: a la fin de chaque round, affiche 
//autant de bombes a cot du nom du joueur  que de rounds gagn
void cPartie::afficherResultat(int numeroJoueur) 
{

	SDL_Color jaune = {254,252,50};
	SDL_Surface* bombe;
	SDL_Surface* fondEcran;
	//on augmente le nombre de victoires d'un joueur.
	_partie[numeroJoueur-1]++;

	fondEcran = ImageLoad("images/menus/fondResultat.bmp");
	
//gestion de l'affichage du nombre de joueurs a l'aide de polices
	SDL_Surface* joueurs[4] = 
	{
		TTF_RenderText_Blended(_police, "Joueur 1 : ", jaune),
		TTF_RenderText_Blended(_police, "Joueur 2 : ", jaune),
		TTF_RenderText_Blended(_police, "Joueur 3 : ", jaune),
		TTF_RenderText_Blended(_police, "Joueur 4 : ", jaune),
	};

	
	
	bombe = ImageLoad("images/bombe1.bmp");
	Uint32 pink = SDL_MapRGB(_ecran->format, 0xFF,0x00,0xFF); 
	SDL_SetColorKey(bombe, SDL_SRCCOLORKEY, pink); 
	

	SDL_Rect position_bombe;

	SDL_Rect position_texte[4];
	position_texte[0].x = 200;
	position_texte[0].y = 350;

	position_texte[1].x = 200;
	position_texte[1].y = 450;

	position_texte[2].x = 200;
	position_texte[2].y = 550;

	position_texte[3].x = 200;
	position_texte[3].y = 650;

	
//affichage de l'cran de rsultat.
	_musiqueResultat.jouer();
	_valider=false;
	while ( ! _valider)
	{
		SDL_BlitSurface(fondEcran, NULL, _ecran, NULL);
		gererClavier();
		for (int i=0; i < _config._nbJoueurs; i++)
		{	
			SDL_BlitSurface(joueurs[i], NULL, _ecran, &position_texte[i]);
			
			//pour chaque joueur, on affiche autant de bombes que de 
			//parties remportes.
			for (int j=0; j < _partie[i]; j++)
			{
				position_bombe.x = 500 + (j * 70);
				position_bombe.y = position_texte[i].y;
				SDL_BlitSurface(bombe, NULL, _ecran, &position_bombe);
			}
		}
		
		SDL_Flip(_ecran);
	}

	//libration mmoire
	SDL_FreeSurface (bombe);
	SDL_FreeSurface (fondEcran);
	for (int i=0; i < 4; i++)
	{
		SDL_FreeSurface (joueurs[i] );
	}
	_musiqueResultat.stop();
}



void cPartie::gererClavier()
{
	SDL_Event event;
    while ( SDL_PollEvent(&event) ) 
	{	
		if ( event.type == SDL_KEYDOWN ) 
		{
			keystroke=event.key.keysym.sym;
			if (keystroke==SDLK_RETURN)
			{
				_valider = true;
			}

			if (keystroke==SDLK_ESCAPE)
			{
				exit(0);
			}
		}
     }
     keys = SDL_GetKeyState(NULL);
}

