/*-----------------------------------------------------------------
/					 Fichier  d'entete CRound.h
/------------------------------------------------------------------
Role: dfinition de la classe CRound, grant un round de jeu
-------------------------------------------------------------------
Versions: (depuis regroupement du 22/12/02)
-------------------------------------------------------------------
23/12/02: regroupement des modifs de Fran et Guillaume
	Appel des fonctions static de chargement d'images de bombes
	et de flammes dans le constructeur, et de destruction dans le 
	destructeur.
4/01/03: Modif du constructeur: passage du nombre de parties.
------------------------------------------------------------------*/
#if !defined(CRound_h)
#define CRound_h

#include <fstream>
#include <SDL/SDL.h>

#include "utils.h"

#include "CContenu.h"
#include "CCase.h"

#include "CFMODMusique.h"

#include "CGestionnaireGamepad.h"
#include "CGestionnaireClavier.h"
#include "CConfiguration.h"

class CCase;


class CRound
{
	public:
		CRound(CConfiguration & config, int* tabPartie,SDL_Surface * ecran);
		CCase * getCase(int x, int y);
		int run();	// renvoie le nummro du joueur vainqueur
		void ajouterContenuADetruire(CContenu * ptADetruire);
		~CRound();


	private:
		void chargerNiveau(ifstream * fichier);
		void chargerJoueur(int nJoueur, int x, int y);
		
		int * _partie;

		int _nbJoueurs;
		int _numVainqueur;
		string _nomNiveau;
	
		
		//CGestionnaireGamepad _gestPad;
		//CGestionnaireClavier _gestClavier;
		vector<CContenu *> _vectADetruire;
		vector<CAvatar *> _vectAvatar;
		CCase * _tabCases[NB_CASES_L][NB_CASES_H];
		
		CFMODMusique _maMusique;

		SDL_Surface * _imageFond;
		SDL_Surface * _imageDessus;

		SDL_Surface * _ecran;
};








#endif /* CCase_h */
