/////////////////////////////////////////////////////////////////////////////
// utils.h
//	 02/01/03: Francois deplacements de #define precedemment dans CRound.h
//  [1/16/2003] ajout de PROBA_BONUS_TELECOMMANDEE + modif de DELAI_IMAGES_BOMBES
/////////////////////////////////////////////////////////////////////////////

#if !defined(utils_h)
#define utils_h

#define DEBUG
//#define NDEBUG	//Macro a definir pour enlever le code de debug (assert...)
#ifndef NDEBUG
	#define DEBUG	// si NDEDUG n'est pas mis alors on est en mode debug
#endif


#include <iostream>
#include <fstream>
#include <string>
#include <vector>	//pour vector

#include <utility>	//pour pair
#include <list>
#include <stdlib.h>
#include <assert.h>
#include <math.h>	// pour fabs (valeur absolue)


#include <SDL/SDL.h>
#include <SDL/SDL_ttf.h>


#include "fmod.h"
#include "fmod_errors.h"

//using namespace std;

typedef enum{MUR_DESTRUCTIBLE, MUR_INDESTRUCTIBLE,
			CASE_LIBRE} type_case;


#define SOUND_PATH "Sound/"
#define NB_BRUITAGES_EXPLOSION 9
#define NB_BRUITAGES_MORT 5

#define NB_CASES_H 13
#define NB_CASES_L 17
#define NB_CASES_TOTAL (NB_CASES_H*NB_CASES_L)
#define NB_JOUEURS_MAX 10	// pour le tableau de bool servant 
							// a detecter la fin de partie

#define PORTEE_DE_BOMBE_INITIALE 2
#define PORTEE_DE_BOMBE_MAX 17


#define TAILLE_SPRITE_X 50
#define TAILLE_SPRITE_Y 50

#define DECALAGE_X 87	// = (1024-(17*50))/2
#define DECALAGE_Y 59	// = (768-(13*50))/2


#define DUREE_IMAGE_AVATAR 120			//la duree entre 2 images de l'avatar
#define DELAI_IMAGES_BOMBES 110

#define DUREE_INVINCIBILITE 10000		//la duree du bonus d'invincibilite: par defaut 10s
#define NB_IMAGES_PAR_DIRECTION 3		//le nombre d'image d'anim dans chaque direction
#define DUREE_DESTRUCTION 1000

#define NB_IMAGES_BOMBES 18
#define NB_IMAGES_BOMBES_TELECOMMANDEES 5


#define VITESSE_CONTENU_PAR_DEFAUT (float)0.006 // exprime en pourcentage de case parcouru par milliseconde
#define VITESSE_MALUS 2		// on divise la vitesse d'un avatar par 2 lorsqu'il est invincible

#define DELTA_POSITION 18	// nombre de pixel (a partir du centre d'une case)
							// a partir duquel le programme decide de repositionner 
							// automatiquement le joueur lorsqu'il veut aller dans une
							// direction. 
							// => il faut minimiser ce parametre le plus possible pour 
							// obtenir un mouvement naturel, mais s'il est trop bas, le
							// deplacement sera impossible sur une machine peu puissante...

#define GAMEPAD_DEPLACEMENT_MINIMUM 10000


#define PROBA_BONUS_PORTEE_MAX		0.02							// soit ...0.03
#define PROBA_BONUS_NB_BOMBES		PROBA_BONUS_PORTEE_MAX + 0.04	// soit ...0.09
#define PROBA_BONUS_PORTEE_BOMBE	PROBA_BONUS_NB_BOMBES + 0.05	// soit ...0.15
#define PROBA_BONUS_INVINCIBILITE	PROBA_BONUS_PORTEE_BOMBE + 0.03	// soit ...0.18
#define PROBA_BONUS_VITESSE			PROBA_BONUS_INVINCIBILITE + 0.06// soit ...0.24
#define PROBA_BONUS_TELECOMMANDEE	PROBA_BONUS_VITESSE + 0.04		// 





SDL_Surface * ImageLoad(const char *file);


#endif

